const ERROR_TOLERANCE = 0.0001;

const PT_FONT_BOLD = "bold " + getFont();
const PT_FONT_NORMAL = getFont();
var PT_FONT = PT_FONT_NORMAL;
const EDGE_FONT_NORMAL = getFont();
const EDGE_FONT_BOLD = "bold " + getFont();
var EDGE_FONT = EDGE_FONT_NORMAL;

const VERTEX_RADIUS_S = 27;
const VERTEX_RADIUS_M = 32;
const VERTEX_RADIUS_L = 37;
var VERTEX_RADIUS = VERTEX_RADIUS_M;
var VERTEX_CLICK_RADIUS = VERTEX_RADIUS + 10;

const ORIGIN_RADIUS = 32;
const ORIGIN_CLICK_RADUIS = ORIGIN_RADIUS + 10;

const AXES_RADIUS = 10;
const AXES_CLICK_RADUIS = AXES_RADIUS + 20;
const ARROW_HEAD_SIZE = 30;
const ARROW_HEAD_SIZE_SMALL = 25;

const VERTEX_LINE_WIDTH = 3;
const VERTEX_LINE_COLOR = "black";
const VERTEX_LABEL_COLOR = "black";

const ORIGIN_LINE_WIDTH = 1;
const ORIGIN_LINE_COLOR = "yellow";
const ORIGIN_FILL_COLOR = "black";

const AXES_LINE_WIDTH = 7;
const AXES_LABELS = ["x", "y"];
const AXES_FILL_COLORS  = ["red", "green"];

const LATTICE_FILL_COLOR = "gray";
const LATTICE_RADIUS = 10;

const UCELL_OPACITY = 0.5;
const UCELL_COLOR = "rgba(220, 220, 220," +  UCELL_OPACITY + ")";

const HIGHLIGHT_OFFSET  = 15;
const HIGHLIGHT_OPACITY = 0.7;
const OTHER_HIGHLIGHT_OPACITY = 0.2;
const HIGHLIGHT_COLOR = "rgba(255,0,0," +  HIGHLIGHT_OPACITY + ")";
const OTHER_HIGHLIGHT_COLOR = "rgba(255,0,0," +  OTHER_HIGHLIGHT_OPACITY + ")";

const EDGE_LINE_COLOR = "black";
const EDGE_LABEL_COLOR = "black";
const EDGE_LINE_WIDTH_THIN = 8;
const EDGE_LINE_WIDTH_NORMAL = 12;
const EDGE_LINE_WIDTH_THICK = 16;
var EDGE_LINE_WIDTH = EDGE_LINE_WIDTH_NORMAL;

const WEIGHT_SPACE_LENGTH = 40;

const VERTEX_DEFAULT_COLOR = "lightgray";
const VERTEX_COLORS = ["deepskyblue", "gold", "hotpink", "greenyellow", "orangered", "limegreen", "mediumvioletred", "darkgray", "skyblue", "chocolate", "mediumspringgreen", "darkviolet", "bisque", "olive", "lavender", "blue",  "aquamarine"];

const EDGE_DEFAULT_COLOR = "darkgray";
const EDGE_COLORS = ["darkorange", "darkmagenta", "lime", "royalblue", "crimson", "darkolivegreen", "deeppink", "teal", "goldenrod", "navy",  "khaki", "darkgreen", "saddlebrown", "yellowgreen", "peachpuff", "gray", "orangered", "palegreen", "rosybrown", "black"];

const FACE_OPACITY = 0.4;
const FACE_DEFAULT_COLOR = "rgba(128,128,128,"+FACE_OPACITY+")";
const FACE_COLORS = ["rgba(255,0,0,"+FACE_OPACITY+")", "rgba(0,255,0,"+FACE_OPACITY+")", "rgba(0,0,255,"+FACE_OPACITY+")", "rgba(255,255,0,"+FACE_OPACITY+")", "rgba(255,0,255,"+FACE_OPACITY+")", "rgba(0,255,255,"+FACE_OPACITY+")", "rgba(255,102,0,"+FACE_OPACITY+")", "rgba(153,204,0,"+FACE_OPACITY+")", "rgba(51,102,255,"+FACE_OPACITY+")", "rgba(255,153,204,"+FACE_OPACITY+")", "rgba(255,204,0,"+FACE_OPACITY+")", "rgba(128,0,128,"+FACE_OPACITY+")", "rgba(128,0,0,"+FACE_OPACITY+")"];

/* https://stackoverflow.com/questions/22943186/html5-canvas-font-size-based-on-canvas-size */
function getFont() {
    var ratio = .2;
    var size = canvas.width * ratio;   // get font size based on current width
    return size + 'px Arial'; // set font
}