/*######################### Listeners #########################*/
//Used for updateColors()
var VBOXES = 0;
var EBOXES = 0;

window.onload = function() {	
  //fragment size listeners
  xSlider.noUiSlider.on('change', getXSliderValues);
  ySlider.noUiSlider.on('change', getYSliderValues);
  right_xSlider.noUiSlider.on('change', getRightXSliderValues);
  right_ySlider.noUiSlider.on('change', getRightYSliderValues);
}

function stateHandler() {
  var states = document.getElementsByName('states');
  var currentState = document.querySelector('input[name="states"]:checked');

  //If the state is origin
  if (currentState.value === "origin") {
    graph.lattice = [];
    document.getElementById('instructions').innerHTML = '<kbd>Click</kbd> a blank space to place or replace the origin <br> \
        <kbd>Click</kbd> + <kbd>Drag</kbd> to move the origin <br><br>';
    if (typeof(graph.origin) === "object" && graph.origin != null) {
      states[1].disabled = false;
      if (graph.axes.length == 2)
        graph.computeLattice(fragSize);
    }
    else {
      graph.reset();
      for (let i = 1; i<states.length; i++) {
        states[i].disabled = true
      }
    }
  }
  else if (currentState.value === "axes") {
    //graph.lattice = [];
    document.getElementById('instructions').innerHTML = '<kbd>Click</kbd> a blank space to place an axis <br> \
        <kbd>Click</kbd> + <kbd>Drag</kbd> to move an axis <br><br>';
    if (graph.axes.length === 2) {
      states[2].disabled = false;
      graph.computeLattice(fragSize);
    }
  }
  else if (currentState.value === "vertices") {
    graph.computeLattice(fragSize);
    document.getElementById('instructions').innerHTML = '<kbd>Click</kbd> a blank space to add a vertex orbit<br> \
        <kbd>Click</kbd> + <kbd>Drag</kbd> to move a vertex orbit<br> \
        <kbd>Crtl</kbd> or <kbd>Cmd</kbd> + <kbd>Click</kbd> to delete a vertex orbit<br><br>';
  }
  else if (currentState.value === "edges") {
    document.getElementById('instructions').innerHTML = '<kbd>Click</kbd> two vertices to add an edge orbit<br> \
    <kbd>Crtl</kbd> or <kbd>Cmd</kbd> + <kbd>Click</kbd> two vertices to delete an edge orbit<br><br>';
    enableDisableAllButtons(states, false);
  }
  else if (currentState.value === "faces") {
    document.getElementById('instructions').innerHTML = '<kbd>Click</kbd> on a sequence of points starting and ending on the same point to draw a face<br> ';
  }
  if (graph.vertices.length >= 2) {
    states[4].disabled = false;
  }
  else {
    graph.edges = [];
    states[4].disabled = true;
  }
  if (graph.vertices.length >= 3) {
    states[5].disabled = false;
  }
  else {
    graph.faces = [];
    states[5].disabled = true;
  }
  
  if (currentState.value === "fragment") {
    document.getElementById('instructions').innerHTML = 'Use the <b>left sliders</b> in the hidden menu at the <b>bottom</b> of the screen to set the fragment size<br><br>';
    states[4].disabled = true;//disable edges radio
    graph.resetFInfo();
    ySlider.removeAttribute('disabled');
    xSlider.removeAttribute('disabled');
    states[3].disabled = false;
    var minSize;
    if (graph.vertexRepsFrac.length > 0) {
      minSize = computeMinFragmentSize(graph);
    }
    else {
      minSize = new FragmentSize(SLIDER_MIN_RANGE);
    }
    if (fragSize.minx > minSize.minx) {
      fragSize.minx = minSize.minx;
    }
    if (fragSize.maxx < minSize.maxx) {
      fragSize.maxx = minSize.maxx;
    }
    if (fragSize.miny > minSize.miny) {
      fragSize.miny = minSize.miny;
    }
    if (fragSize.maxy < minSize.maxy) {
      fragSize.maxy = minSize.maxy;
    }
    graph.makeNewFragment(fragSize);
    xSlider.noUiSlider.set([fragSize.minx, fragSize.maxx]);
    ySlider.noUiSlider.set([fragSize.miny, fragSize.maxy]);
    graph.computeLattice(fragSize);
  }
  else {
    xSlider.setAttribute('disabled', true);
    ySlider.setAttribute('disabled', true);
  }
  
  updateColors(graph);
  drawGraph(canvas, graph, settings);
}

function enableDisableAllButtons(states, bool) {
  for (let i = 0; i < states.length; i++) { 
    states[i].disabled = bool;
  };
}
function updateColors(graph) {
  var string;
  VBOXES = graph.vertexRepsFrac.length;
  EBOXES = graph.edgeReps.length;
  var string = "<label class='colors-label'>Vertex colors:</label>";
  for (let i = 0; i < graph.vertexRepsFrac.length; i++) {
    string += '<div class="form-check form-check-inline"><input class="form-check-input color" type="checkbox" id="vcolor' + i + '" value="show' + i +'" style="background-color:'+ VERTEX_COLORS[i] +'" onclick="setShowVertices(settings, this.id)" checked></div>'
  }
  document.getElementById("vcolors").innerHTML = string; 
  
  var string = "<label class='colors-label'>Edge colors:</label>";
  for (let i = 0; i < graph.edgeReps.length; i++) {
    string += '<div class="form-check form-check-inline"><input class="form-check-input color" type="checkbox" id="ecolor' + i + '" value="show' + i +'" style="background-color:'+ EDGE_COLORS[i] +'" onclick="setShowEdges(settings, this.id)" checked></div>'
  }
  document.getElementById("ecolors").innerHTML = string; 
}
function setShowVertices(settings, id) {
  //console.log("document.getElementById(id).checked: " + document.getElementById(id).checked);
  if (document.getElementById(id).checked) {
    document.getElementById("showVertices").checked = true;
    settings.display.set("showVertices", document.getElementById("showVertices").checked);
  }
  drawGraph(canvas, graph, settings);
  drawGraph(transfCanvas, transfGraph, settings);
}
function setShowEdges(settings, id) {
  if (document.getElementById(id).checked) {
    document.getElementById("showEdges").checked = true;
    settings.display.set("showEdges", document.getElementById("showEdges").checked);
  }
  drawGraph(canvas, graph, settings);
  drawGraph(transfCanvas, transfGraph, settings);
}